/**
 * AttributeDescriptions.java
 *
 * File generated from the core::AttributeDescriptions uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class AttributeDescriptions.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AttributeDescriptions", propOrder = {
	"group"
})
@XmlRootElement(name = "AttributeDescriptions")
public class AttributeDescriptions implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "attribute", namespace = "urn:oasis:names:tc:DSML:2:0:core", type = JAXBElement.class)
		})
	public List<java.io.Serializable> group;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return group.
	 * @return group
	 */
	public List<java.io.Serializable> getGroup() {
		if (group == null) {
	        group = new ArrayList<java.io.Serializable>();
	    }
	    return group;
	}
	
	/**
	 * Set a value to attribute group.
	 * @param group.
	 */
	public void setGroup(List<java.io.Serializable> group) {
	    this.group = group;
	}
	
	
	
	/**
	 * Add a group to the group collection.
	 * @param group_elt Element to add.
	 */
	public void addGroup(java.io.Serializable group_elt) {
	    this.getGroup().add(group_elt);
	}
	
	/**
	 * Remove a group to the group collection.
	 * @param group_elt Element to remove
	 */
	public void removeGroup(java.io.Serializable group_elt) {
	    this.getGroup().remove(group_elt);
	}
	
	/**
	 * Return attribute.
	 * @return attribute
	 */
	public List<net.ihe.gazelle.hpd.AttributeDescription> getAttribute() {
		List<net.ihe.gazelle.hpd.AttributeDescription> attribute_el = new ArrayList<net.ihe.gazelle.hpd.AttributeDescription>();
			for(java.io.Serializable obj : this.getGroup()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("attribute")){
					attribute_el.add( (net.ihe.gazelle.hpd.AttributeDescription) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return attribute_el;
	}
	
	public void addAttribute(net.ihe.gazelle.hpd.AttributeDescription obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.hpd.AttributeDescription> jobj = of.createAttributeDescriptionsAttribute(obj);
		this.getGroup().add(jobj);
	}
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "AttributeDescriptions").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(AttributeDescriptions attributeDescriptions, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (attributeDescriptions != null){
   			cvm.validate(attributeDescriptions, _location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.hpd.AttributeDescription attribute: attributeDescriptions.getAttribute()){
					net.ihe.gazelle.hpd.AttributeDescription.validateByModule(attribute, _location + "/attribute[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}